#include <stdio.h>
#include <ncurses.h>
#include <string.h>

#define BIGCHAR 128                         /* to je číselná hodnota toho nejvyššího bitu */



int getznak(char pole[])                    /* funkce pro načtení vícebajtového znaku */
    {
    int c,i=0;

    if ((pole[i++]=c=getch())&BIGCHAR)      /* načteme znak do proměnné, do pole, a zjistíme nejvyšší bit */
       for (c=c<<1;c&BIGCHAR;c=c<<1)        /* vyhodíme první jedničku posunem a dokud je nějaká další opakujeme */
           pole[i++]=c=getch();             /* načítání do proměnné i pole */
    pole[i]='\0';                           /* potom nesmíme zapomenout ukončit řetězec */

    return pole[0];                         /* vrátíme první znak, aby program věděl kdy má skončit */
    }



void putznak(char pole[])                   /* funkce pro zobrazení vícebajtového znaku */
     {
     printf("%s",pole);                     /* jednoduše vypíšeme celý řetězec */
     }



int povoleny(char pole[])                   /* funkce pro zjištění povolených znaků */
    {
    int i=0;
    char *seznam[]={"A","Á","B","C","Č","D","Ď","E","É","Ě","F","G","H","I",
                    "Í","J","K","L","M","N","Ň","O","Ó","P","Q","R","Ř","S",
                    "Š","T","Ť","U","Ú","Ů","V","W","X","Y","Ý","Z","Ž","\n"};

    for (i=0;i<(sizeof(seznam)/sizeof(*seznam));++i)
        if (!strcmp(pole,seznam[i]))        /* když se řetězce shodují dostaneme nulu */
           return 1;                        /* a vrátíme TRUE */

    return 0;                               /* jinak FALSE */
    }



int shoda(char vzor[],char pole[])
    {
    int i;

    for (i=0;pole[i];++i)
        if (vzor[i]!=pole[i])
           return 0;

    return 1;
    }



int main(void)
    {
    int c;
    int pozice;                             /* pozice ve vzorovém textu */
    char znak[7]={0};                       /* on si to kompilátor stejně zarovná na 8 bajtů */
    char text[1000];                        /* pole pro vzorový text */

    /* přepneme terminál na curses */
    initscr();
    cbreak();                               /* vypneme bufferování */
    noecho();                               /* a výpis znaku na vstupu */
    refresh();

    /*********************************
     *   teď můžeme experimentovat   *
     *********************************/

    /*** psací stroj - ukončení Escape ***/
    printf("Všechny znaky:\r\n");           /* pokyn pro uživatele */
    refresh();
    while (27!=c)                           /* až do Escape */
          {
          c=getch();                        /* vstup znaku */
          if ('\n'==c) putchar('\r');       /* při Enter nejdřív návrat na začátek řádku */
          putchar(c);                       /* výstup znaku se nezobrazí hned */
          refresh();                        /* dokud se neobnoví okno */
          }
    printf("\r\n_Zdrhám odsud!\r\n");       /* pozor na odřádkování CR LF a mizející první znak po Escape */
    refresh();                              /* je potřeba zase obnovit okno aby se text zobrazil */

    /*** a pojedeme naostro ***/
    printf("Pouze velká písmena:\r\n");     /* pokyn pro uživatele */
    refresh();
    while (27!=getznak(znak))               /* vstup znaku a test Escape */
          {
          if ('\n'==znak[0]) putchar('\r'); /* když LF tak nejdřív CR */
          if (povoleny(znak))               /* když je znak v seznamu povolených */
             putznak(znak);                 /* vypíše se */
          refresh();                        /* obnovení okna */
          }
    printf("\r\nTo mi stačilo.\r\n");       /* odřádkování CR LF */
    refresh();                              /* obnovení okna */

    /*** opisování textu ***/
    strcpy(text,"řečiště");                 /* vložení vzoru textu */
    printf("Opisuj text:\r\n%s\r\n",text);  /* pokyn pro uživatele */
    refresh();
    for (pozice=0;text[pozice];)            /* cyklus do konce textu */
        {
        getznak(znak);                      /* načtení klávesy */
        if (shoda(text+pozice,znak))        /* je-li správné písmeno */
           {
           putznak(znak);                   /* zobrazí se */
           pozice+=strlen(znak);            /* a posune o jeho délku */
           }
        else
           flash();                         /* jinak blikne obrazovka */
        refresh();
        }
    printf("\r\nPovedlo se.\r\n");          /* odřádkování CR LF */
    refresh();                              /* obnovení okna */
    beep();                                 /* pípnutí */

    /* na konci opět počkáme na Escape */
    while (27!=getch());

    /*** uklidíme po sobě a vypneme curses ***/
    erase();
    refresh();
    endwin();

    /*** teď už zase fungují standardní funkce normálně a vypisují hned ***/
    printf("A to je konec!\n");
    return 0;
    }
