#include <stdio.h>
#include <ncurses.h>
#include <string.h>

#define BIGCHAR 128                         /* to je číselná hodnota toho nejvyššího bitu */



int getznak(char pole[])                    /* funkce pro načtení vícebajtového znaku */
    {
    int c,i=0;

    if ((pole[i++]=c=getch())&BIGCHAR)      /* načteme znak do proměnné, do pole, a zjistíme nejvyšší bit */
       for (c=c<<1;c&BIGCHAR;c=c<<1)        /* vyhodíme první jedničku posunem a dokud je nějaká další opakujeme */
           pole[i++]=c=getch();             /* načítání do proměnné i pole */
    pole[i]='\0';                           /* potom nesmíme zapomenout ukončit řetězec */

    return pole[0];                         /* vrátíme první znak, aby program věděl kdy má skončit */
    }



void putznak(char pole[])                   /* funkce pro zobrazení vícebajtového znaku */
     {
     printf("%s",pole);                     /* jednoduše vypíšeme celý řetězec */
     }



int shoda(char vzor[],char pole[])
    {
    int i;

    for (i=0;pole[i];++i)
        if (vzor[i]!=pole[i])
           return 0;

    return 1;
    }



int main(void)
    {
    int pozice;                             /* pozice ve vzorovém textu */
    char znak[7]={0};                       /* on si to kompilátor stejně zarovná na 8 bajtů */
    char text[1000];                        /* pole pro vzorový text */

    /* přepneme terminál na curses */
    initscr();
    cbreak();                               /* vypneme bufferování */
    noecho();                               /* a výpis znaku na vstupu */

    /*** opisování textu ***/
    strcpy(text,"řečiště");                 /* vložení vzoru textu */
    printf("Opisuj text:\r\n%s\r\n",text);  /* pokyn pro uživatele */
    for (pozice=0;text[pozice];)            /* cyklus do konce textu */
        {
        getznak(znak);                      /* načtení klávesy */
        if (shoda(text+pozice,znak))        /* je-li správné písmeno */
           {
           putznak(znak);                   /* zobrazí se */
           pozice+=strlen(znak);            /* a posune o jeho délku */
           }
        else
           flash();                         /* jinak blikne obrazovka */
        }
    printf("\r\nPovedlo se.\r\n");          /* odřádkování CR LF */
    beep();                                 /* pípnutí */

    /* na konci opět počkáme na Escape */
    while (27!=getch());

    /*** uklidíme po sobě a vypneme curses ***/
    erase();
    refresh();
    endwin();

    /*** teď už zase fungují standardní funkce normálně a vypisují hned ***/
    printf("A to je konec!\n");
    return 0;
    }
